;;====================================================
;;GD_vieleck_2d
;;os 29.05.2002
;;modifiziert von Highway45
;;am 4.Jan.2005
;;====================================================
(in-package :GD-package)
(use-package :OLI)
;=== Logical table ===
(sd-create-logical-table 
     "Vieleck"
     :columns     '(:SW_UM  :Gewinde)
     :columnNames '("  SW  " "Gewinde")
     :types       '(:length nil)
     :units       '(:mm nil)
     :contents  '(( (4.0 :mm)  M2 ) 
                  ( (5.0 :mm)  M2.5 ) 
		  ( (5.5 :mm)  M3 ) 
		  ( (7.0 :mm)  M4 ) 
		  ( (8.0 :mm)  M5 ) 
		  ( (10.0 :mm)  M6 ) 
		  ( (13.0 :mm)  M8 ) 
		  ( (17.0 :mm)  M10 ) 
		  ( (19.0 :mm)  M12 ) 
		  ( (24.0 :mm)  M16 ) 
		  ( (30.0 :mm)  M20 ) 
		  ( (36.0 :mm)  M24 ) 
		  ( (41.0 :mm)  M27 ) 
		  ( (46.0 :mm)  M30 ) 
		  ( (65.0 :mm)  M42 ) 
 );;contents
 );;sd-create-logical-table
;=== End Logical table ===
(sd-create-display-table
     "Vieleck"
     :tableTitle         "Auswahl Schlsselweite"
     :logicalTable       "Vieleck"
     :columns            '(:SW_UM :Gewinde)
     :columnSortUI       t
     :entryAlignment     '(:right :left)
     :applyColumns       '(:SW_UM)
     :formatFunctions    '(sd-display-table-format-1-digit)
     :displayHeight      170
     :filterStatusLine   nil
     :selectionMode      :single-row 
     :applyAction        :default-tokens
);;sd-create-display-table
;;=============================
(defun gd-show-vieleck-table ()
  (sd-show-display-table "Vieleck"
     :position '("TOP-MENU-TOOLBOX-TB" :center 108 -108)))
(defun gd-hide-vieleck-table ()
  (sd-hide-display-table "Vieleck" :ignorePin t))
;;=============================
(sd-defdialog 'GD_vieleck_2d
  :dialog-title "3D Vielecke"
  :toolbox-button t
  :start_variable 'ECKZAHL
  :variables '(
    (WP
             :value-type :wp
             :title "Arbeitsebene"
             :prompt-text "AE angeben"
             :initial-value (sd-inq-curr-wp) )
    (MPKT
             :value-type :point-2d
             :Title "Mittelpunkt"
             :Prompt-text "Mittelpunkt angeben")
    (WINKEL  
             :value-type :angle
             :title "Neigung"
	     :prompt-text "Neigung zur Waagerechten"
	     :initial-value 0)
    (ECKZAHL 
             :value-type :positive-integer
             :title "Seitenzahl"
             :direction :input
             :prompt-text "Seitenzahl eingeben."
             :initial-value 6 )
    (SW_UM  
             :value-type :positive-number
             :title "SW / UM"
	     :show-input-tool (gd-show-vieleck-table)
	     :hide-input-tool (gd-hide-vieleck-table)
	     :prompt-text "Schlsselweite bzw. Umkreisdurchmesser eingeben."
             :initial-value 10 )
    (INKR
	     :value-type :boolean
	     :toggle-type :wide-toggle
	     :initial-value t
	     :title "SW   Schlsselweite")
    (UMKR
	     :value-type :boolean
	     :toggle-type :wide-toggle
	     :title "UM Umkreisdurchmesser")
    (PICTURE
     :value-type :image
     :image-file "c:/...installationspfad.../.../AE_Vielecke.bmp"
     :image-width 128
     :image-height 64
     :image-alignment :center)
    (NEXT    
             :push-action (os-vieleck-2d-erstellen)
	     :after-input (setf MPKT nil)
	     :next-variable 'MPKT)
  );;variables 
 :mutual-exclusion '(INKR UMKR)
 :local-functions '(
  (os-vieleck-2d-erstellen ()
   (sd-call-cmds
    (progn
     (let (RAD_ID ALFAP ALFAS ALFAB ALFAC Counter X0 X1 XP Y0 Y1 YP)
       (setq RAD_ID (/ SW_UM 2))
       (c_circle :radius RAD_ID MPKT)
       (setq ALFAP (/ (- 180 (/ 360 ECKZAHL)) 2))
       (setq ALFAS (/ 360 ECKZAHL))
       (setq ALFAB (+ ALFAP (/ (* WINKEL 360) (* pi 2))))
       (if INKR
           (setq RAD_ID (/ RAD_ID (sin (sd-deg-to-rad ALFAP)))) 
       );;if
       (dotimes (Counter ECKZAHL)
         (setq ALFAC (+ ALFAB (* ALFAS counter)))
         (setq X1 (* RAD_ID (cos (sd-deg-to-rad ALFAC) )))
         (setq Y1 (* RAD_ID (sin (sd-deg-to-rad ALFAC) )))
         (setq X1 (+ X1 (gpnt2d_x MPKT)))
         (setq Y1 (+ Y1 (gpnt2d_y MPKT)))
         (cond
           ((> Counter 0)
            (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x X1 :y Y1))
           ) 
           ((= Counter 0)
            (setq XP X1)
            (setq YP Y1)
           )
         );;cond
         (setq X0 X1)
         (setq Y0 Y1)
       );;dotimes
       (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x XP :y YP))
     );;let
    );;progn
   );;sd-call-cmds
  );;os-vieleck-2d-erstellen
 );;local-functions
 :ok-action '(os-vieleck-2d-erstellen)
);;sd-defdialog
